Create a tag indexing rule exemption

Note: The Tag Indexing Rules feature is currently in Preview. If you have any feedback, contact Datadog support.

POST https://api.ap1.datadoghq.com/api/v2/metrics/{metric_name}/tag-indexing-rule-exemptionshttps://api.ap2.datadoghq.com/api/v2/metrics/{metric_name}/tag-indexing-rule-exemptionshttps://api.datadoghq.eu/api/v2/metrics/{metric_name}/tag-indexing-rule-exemptionshttps://api.ddog-gov.com/api/v2/metrics/{metric_name}/tag-indexing-rule-exemptionshttps://api.us2.ddog-gov.com/api/v2/metrics/{metric_name}/tag-indexing-rule-exemptionshttps://api.uk1.datadoghq.com/api/v2/metrics/{metric_name}/tag-indexing-rule-exemptionshttps://api.datadoghq.com/api/v2/metrics/{metric_name}/tag-indexing-rule-exemptionshttps://api.us3.datadoghq.com/api/v2/metrics/{metric_name}/tag-indexing-rule-exemptionshttps://api.us5.datadoghq.com/api/v2/metrics/{metric_name}/tag-indexing-rule-exemptions

Overview

Exempt a metric from all tag indexing rules. The response includes the created exemption resource. Requires the Manage Tags for Metrics permission. This endpoint requires the metric_tags_write permission.

OAuth apps require the metric_tags_write authorization scope to access this endpoint.

Arguments

Path Parameters

Name

Type

Description

metric_name [required]

string

The name of the metric.

Request

Body Data (required)

Expand All

Field

Type

Description

data [required]

object

Data object for creating a tag indexing rule exemption.

attributes [required]

object

Attributes for creating a tag indexing rule exemption.

reason [required]

string

The reason the metric is exempt from tag indexing rules.

type [required]

enum

The tag indexing rule exemption resource type. Allowed enum values: tag_indexing_rule_exemptions

default: tag_indexing_rule_exemptions

{
  "data": {
    "attributes": {
      "reason": "This metric has a pre-existing tag configuration."
    },
    "type": "tag_indexing_rule_exemptions"
  }
}

Response

Created

Response containing a tag indexing rule exemption.

Expand All

Field

Type

Description

data

object

A tag indexing rule exemption resource object.

attributes

object

Attributes of a tag indexing rule exemption.

created_at

date-time

Timestamp when the exemption was created.

created_by_handle

string

Handle of the user who created the exemption.

kind

string

Discriminates between an explicit exemption (exemption) and a pre-existing legacy tag configuration acting as an implicit exclusion (legacy_tag_configuration).

reason

string

The reason the metric is exempt from tag indexing rules.

id

string

The metric name, used as the resource ID.

type

enum

The tag indexing rule exemption resource type. Allowed enum values: tag_indexing_rule_exemptions

default: tag_indexing_rule_exemptions

{
  "data": {
    "attributes": {
      "created_at": "2024-01-15T12:00:00.000Z",
      "created_by_handle": "user@datadoghq.com",
      "kind": "exemption",
      "reason": "This metric has a pre-existing tag configuration."
    },
    "id": "dd.test.metric",
    "type": "tag_indexing_rule_exemptions"
  }
}

Bad Request

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Forbidden

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Too Many Requests

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Code Example

                  ## default
# 

# Path parameters
export metric_name="dist.http.endpoint.request"
# Curl command
curl -X POST "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/metrics/${metric_name}/tag-indexing-rule-exemptions" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "DD-API-KEY: ${DD_API_KEY}" \ -H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \ -d @- << EOF { "data": { "attributes": { "reason": "This metric has a pre-existing tag configuration." }, "type": "tag_indexing_rule_exemptions" } } EOF
"""
Create a tag indexing rule exemption returns "Created" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.metrics_api import MetricsApi
from datadog_api_client.v2.model.tag_indexing_rule_exemption_create_attributes import (
    TagIndexingRuleExemptionCreateAttributes,
)
from datadog_api_client.v2.model.tag_indexing_rule_exemption_create_data import TagIndexingRuleExemptionCreateData
from datadog_api_client.v2.model.tag_indexing_rule_exemption_create_request import TagIndexingRuleExemptionCreateRequest
from datadog_api_client.v2.model.tag_indexing_rule_exemption_type import TagIndexingRuleExemptionType

body = TagIndexingRuleExemptionCreateRequest(
    data=TagIndexingRuleExemptionCreateData(
        attributes=TagIndexingRuleExemptionCreateAttributes(
            reason="This metric has a pre-existing tag configuration.",
        ),
        type=TagIndexingRuleExemptionType.TAG_INDEXING_RULE_EXEMPTIONS,
    ),
)

configuration = Configuration()
configuration.unstable_operations["create_tag_indexing_rule_exemption"] = True
with ApiClient(configuration) as api_client:
    api_instance = MetricsApi(api_client)
    response = api_instance.create_tag_indexing_rule_exemption(metric_name="metric_name", body=body)

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
# Create a tag indexing rule exemption returns "Created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.create_tag_indexing_rule_exemption".to_sym] = true
end
api_instance = DatadogAPIClient::V2::MetricsAPI.new

body = DatadogAPIClient::V2::TagIndexingRuleExemptionCreateRequest.new({
  data: DatadogAPIClient::V2::TagIndexingRuleExemptionCreateData.new({
    attributes: DatadogAPIClient::V2::TagIndexingRuleExemptionCreateAttributes.new({
      reason: "This metric has a pre-existing tag configuration.",
    }),
    type: DatadogAPIClient::V2::TagIndexingRuleExemptionType::TAG_INDEXING_RULE_EXEMPTIONS,
  }),
})
p api_instance.create_tag_indexing_rule_exemption("metric_name", body)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
// Create a tag indexing rule exemption returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.TagIndexingRuleExemptionCreateRequest{
		Data: datadogV2.TagIndexingRuleExemptionCreateData{
			Attributes: datadogV2.TagIndexingRuleExemptionCreateAttributes{
				Reason: "This metric has a pre-existing tag configuration.",
			},
			Type: datadogV2.TAGINDEXINGRULEEXEMPTIONTYPE_TAG_INDEXING_RULE_EXEMPTIONS,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateTagIndexingRuleExemption", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewMetricsApi(apiClient)
	resp, r, err := api.CreateTagIndexingRuleExemption(ctx, "metric_name", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `MetricsApi.CreateTagIndexingRuleExemption`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `MetricsApi.CreateTagIndexingRuleExemption`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
// Create a tag indexing rule exemption returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.MetricsApi;
import com.datadog.api.client.v2.model.TagIndexingRuleExemptionCreateAttributes;
import com.datadog.api.client.v2.model.TagIndexingRuleExemptionCreateData;
import com.datadog.api.client.v2.model.TagIndexingRuleExemptionCreateRequest;
import com.datadog.api.client.v2.model.TagIndexingRuleExemptionResponse;
import com.datadog.api.client.v2.model.TagIndexingRuleExemptionType;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.createTagIndexingRuleExemption", true);
    MetricsApi apiInstance = new MetricsApi(defaultClient);

    TagIndexingRuleExemptionCreateRequest body =
        new TagIndexingRuleExemptionCreateRequest()
            .data(
                new TagIndexingRuleExemptionCreateData()
                    .attributes(
                        new TagIndexingRuleExemptionCreateAttributes()
                            .reason("This metric has a pre-existing tag configuration."))
                    .type(TagIndexingRuleExemptionType.TAG_INDEXING_RULE_EXEMPTIONS));

    try {
      TagIndexingRuleExemptionResponse result =
          apiInstance.createTagIndexingRuleExemption("dist.http.endpoint.request", body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling MetricsApi#createTagIndexingRuleExemption");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
// Create a tag indexing rule exemption returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_metrics::MetricsAPI;
use datadog_api_client::datadogV2::model::TagIndexingRuleExemptionCreateAttributes;
use datadog_api_client::datadogV2::model::TagIndexingRuleExemptionCreateData;
use datadog_api_client::datadogV2::model::TagIndexingRuleExemptionCreateRequest;
use datadog_api_client::datadogV2::model::TagIndexingRuleExemptionType;

#[tokio::main]
async fn main() {
    let body = TagIndexingRuleExemptionCreateRequest::new(TagIndexingRuleExemptionCreateData::new(
        TagIndexingRuleExemptionCreateAttributes::new(
            "This metric has a pre-existing tag configuration.".to_string(),
        ),
        TagIndexingRuleExemptionType::TAG_INDEXING_RULE_EXEMPTIONS,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.CreateTagIndexingRuleExemption", true);
    let api = MetricsAPI::with_config(configuration);
    let resp = api
        .create_tag_indexing_rule_exemption("metric_name".to_string(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
/**
 * Create a tag indexing rule exemption returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.createTagIndexingRuleExemption"] = true;
const apiInstance = new v2.MetricsApi(configuration);

const params: v2.MetricsApiCreateTagIndexingRuleExemptionRequest = {
  body: {
    data: {
      attributes: {
        reason: "This metric has a pre-existing tag configuration.",
      },
      type: "tag_indexing_rule_exemptions",
    },
  },
  metricName: "metric_name",
};

apiInstance
  .createTagIndexingRuleExemption(params)
  .then((data: v2.TagIndexingRuleExemptionResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"